Unit ZF13R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF13R(F :Func_F1; N :Integer; EPS :Real; NDIG :Integer;
                EPS1 :Real; EPS2 :Real; var ROOT :Array of Real;
                var ITMAX :Integer; var IERR :Integer);

implementation

procedure ZF13R(F :Func_F1; N :Integer; EPS :Real; NDIG :Integer;
                EPS1 :Real; EPS2 :Real; var ROOT :Array of Real;
                var ITMAX :Integer; var IERR :Integer);
var
I,JK,L,NSIG :Integer;
BI,D,DD,DI,DN,DM,DEN,DIGT,FRT,FPRT,H,RT,TEM,X0,X1,X2,P,P1,P2 :Real;
const
TEN :Real = 10.0E0;
ONE :Real = 1.0E0;
ZERO :Real = 0.0E0;
P9 :Real = 0.9E0;
P11 :Real = 1.1E0;
HALF :Real = 0.5E0;
PP1 :Real = 0.1E0;
F4 :Real = 4.0E0;
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20;
begin
IERR := 0;
NSIG := NDIG;
if ( NDIG = 0 ) and ( EPS = 0.0 ) 
 then NSIG := 5;
DIGT := Power(TEN,-NSIG);
P := -ONE;
P1 := ONE;
P2 := ZERO;
H := ZERO;
for L:=1 to N do
 begin
  JK := 0;
  if ( ROOT[L-1] = ZERO ) 
   then goto _1;
  P := P9*ROOT[L-1];
  P1 := P11*ROOT[L-1];
  P2 := ROOT[L-1];
_1:
  RT := P;
  goto _13;
_2:
  if ( JK <> 1 ) 
   then goto _3;
  RT := P1;
  X0 := FPRT;
  goto _13;
_3:
  if ( JK <> 2 ) 
   then goto _4;
  RT := P2;
  X1 := FPRT;
  goto _13;
_4:
  if ( JK <> 3 ) 
   then goto _11;
  X2 := FPRT;
  D := -HALF;
  if ( ROOT[L-1] = ZERO ) 
   then goto _5;
  H := -PP1*ROOT[L-1];
  goto _6;
_5:
  H := -ONE;
_6:
  DD := ONE+D;
  BI := X0*IntPower(D,2)-X1*IntPower(DD,2)+X2*(DD+D);
  DEN := IntPower(BI,2)-F4*X2*D*DD*(X0*D-(X1*DD)+X2);
  if ( DEN <= ZERO ) 
   then goto _7;
  DEN := Sqrt(DEN);
  goto _8;
_7:
  DEN := ZERO;
_8:
  DN := BI+DEN;
  DM := BI-DEN;
  if ( Abs(DN) <= Abs(DM) ) 
   then goto _9;
  DEN := DN;
  goto _10;
_9:
  DEN := DM;
_10:
  if ( DEN = ZERO ) 
   then DEN := ONE;
  DI := -DD*(X2+X2)/DEN;
  H := DI*H;
  RT := RT+H;
  if ( NSIG = 0 ) 
   then goto _13;
  if ( Abs(H) < Abs(RT)*DIGT ) 
   then goto _18;
  goto _13;
_11:
  if ( Abs(FPRT) >= Abs(X2*10.E0) ) 
   then goto _12;
  X0 := X1;
  X1 := X2;
  X2 := FPRT;
  D := DI;
  goto _6;
_12:
  DI := DI*HALF;
  H := H*HALF;
  RT := RT-H;
_13:
  JK := JK+1;
  if ( JK < ITMAX ) 
   then goto _14;
  IERR := 1;
  ROOT[L-1] := SYS059;
  goto _19;
_14:
  FRT := F(RT);
  FPRT := FRT;
  if ( L < 2 ) 
   then goto _16;
  for I:=2 to L do
   begin
    TEM := RT-ROOT[I-2];
    if ( Abs(TEM) < Abs(EPS1) ) 
     then goto _17;
    FPRT := FPRT/TEM;
_15:
   end;
_16:
  if ( (Abs(FRT) < Abs(EPS)) ) and ( (Abs(FPRT) < Abs(EPS)) )
   then goto _18;
  goto _2;
_17:
  RT := RT+EPS2;
  JK := JK-1;
  goto _13;
_18:
  ROOT[L-1] := RT;
_19:
 end;
ITMAX := JK;
if ( IERR = 0 ) 
 then goto _20;
UTZF10(IERR,13);
_20:
end;

end.
